#v1.3#Thanks for BAD,Tang
try:
    from vcCommand import * 
    import vcMatrix, vcVector
    import csv
    from vcScript import *
    from vcHelpers.Selection import *
except:
    print "Modules not found"

cmd = getCommand()
app = cmd.Application
sim = cmd.Simulation

def OnStart():
  global path, import_option, btn_click
  global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild

  path = cmd.createProperty(VC_URI, 'Select CSV')
  import_option = cmd.createProperty(VC_STRING, 'Import as', VC_PROPERTY_STEP)
  import_option.StepValues = ['ImportPropertyList']
  import_option.Value = 'ImportPropertyList'
  btn_click = cmd.createProperty(VC_BUTTON, 'Import')
  executeInActionPanel()
  btn_click.OnChanged = ImportFromCSV


def addProperty():
    global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild,Property_UpdateSimulation
    comps = getSelectedComponents()

    if not comps:
        return
    # 为组件添加属性
    for comp in comps:
        Foo = comp.getProperty(Property_Name)
        
        if not Foo:
            Foo=comp.createProperty(VCProperty_Type,Property_Name)
        try:
            Foo.Value = Property_Value
        except:
            pass
        try:
            Foo.ChangeOnRebuild = Property_Rebuild
        except:
            pass
        try:
            Foo.ChangeOnUpdate = Property_UpdateSimulation
        except:
            pass

        print("Property added to component .")

def ImportFromCSV(prop):
  '''
  Import from cvs file row format\n
  Name,Type,Value,Rebuild,Update simulation
  Property1,Real,5.23,True,False
  Property2,Integer,11,False,True
  Property3,Boolean,TRUE,True,False
  Property4,String,A001,False,True
  '''
  global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild,Property_UpdateSimulation

  uri = path.Value[8:]
  with open(uri) as csv_file:
    next(csv_file) #Skip the first line
    csv_reader = csv.reader(csv_file, delimiter = ',')
    for row in csv_reader:
      Property_Name = str(row[0])
      Property_Type = str(row[1])
      if Property_Type == 'Boolean':
        VCProperty_Type = VC_BOOLEAN
        Property_Value = str(row[2])
      if Property_Type == 'String':
        VCProperty_Type = VC_STRING
        Property_Value = str(row[2])
      if Property_Type == 'Integer':
        VCProperty_Type = VC_INTEGER
        Property_Value = int(row[2])
      if Property_Type == 'Real':
        VCProperty_Type = VC_REAL
        Property_Value = float(row[2])
        '''
      if str(row[3])== 'TRUE'or'True':
        Property_Rebuild = True
      elif str(row[3])== 'FALSE'or'False':
        Property_Rebuild = False
      Property_Rebuild=str(row[3])
       
      if str(row[4])== 'TRUE'or'True':
        Property_UpdateSimulation = True
      elif str(row[4])== 'FALSE'or'False':
        Property_UpdateSimulation = False
        '''
      Property_UpdateSimulation = True
      #Property_Rebuild = str(row[3])
      Property_Rebuild = False
      #Property_UpdateSimulation = str(row[4])
      addProperty()

def SimulationOnStartStop(sim, IsRunning):
  cmd.Enabled = True
  if IsRunning:
    cmd.Enabled = False
  else:
    cmd.Enabled = True

sim.OnStartStop = SimulationOnStartStop
